{-# OPTIONS -Wall #-}

{- OBS! Compile this program with
   $ ghc --make -O3 CheckInsert.hs -main-is CheckInsert.main
-}

--------------------------------------------------------------------------------

module CheckInsert where

import Data.List ( permutations )
import RedBlackTree

--------------------------------------------------------------------------------
-- check insertion

main :: IO ()
main = mapM_ checkTreesOfSize [1..9]

checkTreesOfSize :: Int -> IO ()
checkTreesOfSize n = 
  do putStrLn ("Testing trees of size " ++ show n)
     mapM_ checkTreeFromList (permutations [1..n])

checkTreeFromList :: [Int] -> IO ()
checkTreeFromList list
  | checkTree tree' = return ()
  | otherwise = do putStrLn ("\nInvariant not true after inserting\n  " ++ show (head list) ++
                             "\ninto\n  " ++ show tree ++
                             "\nresulting tree was\n  " ++ show tree')
                   fail "bad tree"
  where tree = foldr insert emptyTree (tail list)
        tree' = insert (head list) tree

